      LOGICAL FUNCTION  TOKLMO (K1,K2,LL)
C
C     RECOGNIZE A TYPE STATEMENT LENGTH MODIFIER IN STMT(K1) -
C     STMT(K2-1), RETURNING .TRUE. IF FOUND, WITH LL SET TO THE
C     VALUE OF THE LENGTH MODIFIER.  K1 IS NOT ALTERED, K2 AND
C     LL ARE UPDATED ON RETURN.  A .FALSE. RETURN HAS LL = 0.
C
      INTEGER STMT, PSTMT
      LOGICAL TOKPNO
      COMMON /INPUT/ NSTMT, PSTMT, STMT(1327)
      TOKLMO = .FALSE.
      LL = 0
      CALL NEXTOK (K1,K2,K)
C
C     RETURN IF AN ASTERISK WAS NOT FOUND.
C
      IF (.NOT.( (K .EQ. 3) .AND. (STMT(K2-1) .EQ. 66) )) RETURN
C
C     AN ASTERISK WAS FOUND, SO EXTRACT THE FOLLOWING POSITIVE
C     DIGIT STRING AND RETURN ITS VALUE IN LL.
C
      K = K2
      TOKLMO = TOKPNO (K,K2,LL)
      RETURN
      END
